//This file is create_noccupancy.cc
//Function definition of memeber function create_noccupancy() of class Lattice
//By Teck Leong Tan

#include "lattice.h"
//#include "filenames.h"

//This functions initialises the occupation of lattice sites

void Lattice::create_noccupancy()
{
  CellO vcello; //a vacant variable, for assigning purposes
  SiteO vsiteo; //a vacant variable, for assigning purposes
  //cout<<"create_noccu...line14"<<endl;
  fstream inconfig;
  //cout<<inconfig<<endl;
  inconfig.open(inconf0, ios::in);
  //cout<<inconfig<<endl;
  //cout<<"noccupancy.size()"<<endl;
  noccupancy.assign(nsize,vcello);
  //cout<<"noccupancy.size()"<<endl;
  //cout<<"create_noccu... line18"<<endl;
  if (restart==1 && inconfig){ //read lattice from a file:
    for (int ijk=0; ijk<nsize;ijk++)
    { 
      noccupancy[ijk].site.assign(num_sublat, vsiteo);
      //Loop over no. of sublattices
      for (int l=0; l<num_sublat;l++)
      {
	      noccupancy[ijk].site[l].atomtype=0;
      }
    }//end for (int ijk=0; ijk<nsize;ijk++)
    //cout<<"noccupancy initialised, it's size= "<<noccupancy.size()<<endl;

    //read lattice from a file, if file exists:
    read_config(inconfig);
  }
  else if (restart==2)
  { /*Generate lattice with composition given in init_conc:
      1. Calculate initial no. of each atom species.
      2. Go to each lattice site and populate site in a sequential manner
         i.e site 1 with at. sp 0, site 2 with at. sp 1,.... If the no. for
         that species =0, populate it with the subsequent species.
      3. Subtract 1 from relevant species the initial number.
      4. Prints the configuration to file. (See filenames.h)
    */     
    vector <int> init_number;//Initial no. of each atom species
    vector <int> index;//Index of atom species corresponding to init_number
    int temp=0;//For counting of no. of atoms for species 1 to numtype
    
    //Sets up the initial number of atom species (0 to numtype)----------------
    //Loop over species 1 to numtype
    cout<<"(int)init_conc[0]*natoms= "<<(int)(init_conc[0]*natoms)<<endl;
    for (int i=0; i<init_conc.size();i++)
    {
      temp+=(int)(init_conc[i]*natoms);
      if ((int)(init_conc[i]*natoms)>0)
      {  
        init_number.push_back((int)(init_conc[i]*natoms));
        index.push_back((i+1));
      }
    }
    if ((natoms-temp)<0)
    {
	    //cout<<"Error in init_occupancy.cc: Given concentration exceeds 1"<<endl;
      exit (1);
    }  
    if ((natoms-temp)>0)
    {
      init_number.push_back((natoms-temp));//Initial conc. for species 0
      index.push_back(0);
    }
    //End of set up-----------------------------------------------------------
    //cout<<"Size of init_number= "<<init_number.size()<<endl;
    //cout<<"init_number= "<<init_number[0]<<" "<<init_number[1]<<endl;
    //cout<<"index= "<<index[0]<<"  "<<index[1]<<endl; 
    //The following will populate the lattice 
    for (int ijk=0; ijk<nsize;ijk++)
    { 
      noccupancy[ijk].site.assign(num_sublat, vsiteo);
      //Loop over no. of sublattices 
      for (int l=0; l<num_sublat;l++)
      {
        int temp, check;
        temp=ijk%(index.size());
        check=0;
        while (init_number[temp]<=0)
        {
	        temp++;
          if (temp>=index.size())
          {
	          temp-=index.size();
          }
          check++;
          if (check>=index.size())
          {
	          cout<<"create_noccupancy.cc line 97: Problem with creating lattice"<<endl;
          }
        }
        noccupancy[ijk].site[l].atomtype=index[temp];//Populate lattice site
        //cout<<temp;
        init_number[temp]-=1;
      }
    }  
  }//end else if (restart==2)     
                    
  else
  { //Start from empty lattice: generate random noccupancy:
    //cout<<"create_noccu. line97"<<endl;
    if (restart==1 && !inconfig)
    { //Print statement if restart==1 but config file unavailable
      cout<<inconf0<<" not found. Start from randomised lattice."<<endl;
    }    
    //noccupancy.assign(nsize,vcello);
    //cout<<"Size of noccupancy= "<<noccupancy.size()<<endl;
    //cout<<"nsize= "<<nsize<<endl;
    //Loop over no. of cells
    for (int ijk=0; ijk<nsize;ijk++)
    { 
      noccupancy[ijk].site.assign(num_sublat, vsiteo);
      //Loop over no. of sublattices
      for (int l=0; l<num_sublat;l++)
      {
	      noccupancy[ijk].site[l].atomtype=rand()%(1+num_type);
      }
    }//end for (int ijk=0; ijk<nsize;ijk++)
  }//end_if (restart==0)
  //cout<<"create_noccupancy line 26"<<endl;
  //cout<<"Size of noccupancy= "<<noccupancy.size()<<endl;
  //cout<<"Size of noccupancy.site= "<<noccupancy[0].site.size()<<endl;
  inconfig.close();

  //Print configuration to a file
  fstream init_config;
  init_config.open(start_conf, ios::out);
  //for (int ijk=0; ijk<nsize; ijk++){
      //Loop over sublattice
      //for (int l=0; l<num_sublat;l++){
  //init_config<<noccupancy[ijk].site[l].atomtype;
  //}
  //}
  print_config(init_config);
  init_config.close();
}

//EOF
	
