//This file is monte_carlo.cc
//Function definition of memeber function grandmcs() of class Lattice
//By Teck Leong Tan

#include "lattice.h"
#define SCALE_FACTOR 1e-20

//This functions initialises the lattice and does grand canonical MC

int Lattice::monte_carlo()

{
  //double beta; //Temporary
  //beta=1/Tinit;
  
  cout<<"In function monte_carlo()"<<endl;
  cout<<"ndim is "<<ndim<<endl;
  cout<<"numpass is "<<numpass<<endl;
  cout<<"num_type is "<<num_type<<endl;
  
  int passes=0;
  int noccu;
  fstream output, outputh, output2, output3, config;// outcor_pair, outcor_LRO;
  srand(randseed);
  
  if (correlation_option==0)
  {
    //Opening files for output---------------------------------------------------
    output.open(outputfile, ios::out);//Main outputfile. Properties at each T and chem pot
    if (!output)
    {
      cout<<"File "<<outputfile<<" is not opened!"<<endl;
      exit(1);
    }
    if (num_runs>1)
    {
      outputh.open(outputfileh, ios::out);//Main outputfile(heating). Properties at each T and chem pot
      if (!outputh)
      {
        cout<<"File "<<outputfileh<<" is not opened!"<<endl;
        exit(1);
      }
    }
    output2.open(outputfile2, ios::out);// U4 using 4th moment of energy
    if (!output2)
    {
      cout<<"File "<<outputfile2<<" is not opened. No results for U4."<<endl;
      //exit(1);
    }
    output3.open(outputfile3, ios::out);//Energy at each pass. 
    if (!output3)
    {
      cout<<"File "<<outputfile3<<" is not opened. "<<endl;
      //exit(1);
    }  
    config.open (outconfigT, ios::out);//Configuration at each temperature.
    if (!config)
    {
      cout<<"File config.out is not opened!"<<endl;
      exit(1);
    } 
    //output<<"#T,       eavg,         e_instant,   Cv,          conc,      mu"<<endl;
    output<<"#T,       "<<"eavg,         "<<"e instant,    "<<"Cv,             ";
    output2<<"#T,       "<<"U4,      ";
    output3<<"#Pass,       "<<" e instant,   "<<endl;
    for (int i=1;i<=num_type;i++)
    {
      output<<"conc "<<i<<",    "<<"mu "<<i<<",     ";
      output2<<"mu "<<i<<",     ";

    } 
    output<<endl;
    output2<<endl;

    //End of opening output files------------------------------------------------

    //Determine which atomic type's mu conditions to loop over------------------
    //mu_step is determined by atomic species with least mu_steps 
    int mu_steps=0;
    E_struct.V0 = clustree.sublat[0].nbody[0].nclus[0]->Vin[0];
    
    //Loop over atomic types and compare the num of mu steps
    for(int i=0; i<num_type;i++)
    {
      double tempmud;
      int tempmu;
      tempmud=(mu_final[i]-mu_init[i])/mu_increment[i];
      tempmu=(int)tempmud;
      if (tempmu<0)
      { 
	      tempmu=0;
      }
      else if (abs(tempmud-tempmu)>0.9999)
      {
	      tempmu+=1 ;
      }
      //tempmu=abs((int)((mu_final[i]-mu_init[i])/mu_increment[i]));
      if (tempmu > mu_steps)
      { 
	      //mu_steps is the no. of steps for mu loop 
	      mu_steps=tempmu;
      }
    }
    //-------------------------------------------------------------------

    //Determine the number of temperature steps-------------------------
    /*double Tstepsd;
    int Tsteps;
    Tstepsd=(Tfinal-Tinit)/Tincrement;
    Tsteps=(int)Tstepsd;
    if (Tsteps<0)
    { 
      Tsteps=0;
    }
    else if (abs(Tstepsd-Tsteps)>0.9999)
    {
      Tsteps+=1 ;
      }*/

    //------------------------------------------------------------------


    //Monte Carlo  simulation====================================================

    //Calculate energy of initial system---------------------------------
  
    cal_conc();//Calculate the conc. of initial configuration

    //The real simulation------------------------------------------------
    /* The simulation is done in the following manner:
       1. Loops over each chemical potential,temperature & passes.
       2. Energy of lattice with new chem. pot. is calculated
       3. Calls functions metro_grand or metro_canon to calculate energy
	        for each pass.Energy changes, concentration changes and related
	        terms for each pass are summed up.
	         E.g E_struct.dEsumpass+=E_struct.dEpass
       4. Calculates average terms for energy, energy^2 and concentration
       5. Calls function print_output.
    */

    //Loop over Chem. Potential
    for (int mu=0; mu <=mu_steps;mu++)
    {
      
      //Loop over sublattice
      for (int l=0; l<num_sublat;l++)
      {
	      //Loop over no. of atomic species
	      for (int k=0;k<num_type;k++)
	      {
	        clustree.sublat[l].nbody[1].nclus[0]->Vin[k]=mu_init[k]+mu_increment[k]*mu;
	      }
      }//end for (int l=0; l<num_sublat;l++)

      E_struct.E=eEnergy();//The system is initialised with new chem pot.
      double tempd;//For temporary storage.

      //The following is for temperature scaling.
      //The scaling is: (dCv_old/dCv_new)dT_old = dT_new
      E_struct.dCv_old=100;//For temperature scaling
      E_struct.Cv_old=0;//For temperature scaling
      double Tchange=Tincrement;//Temperature interval, this will be used instead of Tincrement.
      double T=Tinit;//Temperature, T
      

      //Loop num_runs
      for (int run=0;run<num_runs;run++)
      { 
        if(run>0){T=Tfinal;}//The 2nd run should start from the end temperature of 1st run

        //While temperature between the user specified values
          while (T>=(Tinit<?Tfinal) && T<=(Tinit>?Tfinal))
        { //Initilaisation-------------------------------------------------------
          
          /*double T;
          if (run>0)
          {
            T=Tfinal-Tincrement*temp;
          }
          else
          {
            T=Tinit+Tincrement*temp;
            }*/
          E_struct.Estart=E_struct.E;//Starting energy of sys.=sys. energy from previous loop over T
          E_struct.dEpass=0;
          E_struct.dEsumpass=0;
          E_struct.E=0;
          E_struct.Eavg=0;
          E_struct.e=0;
          E_struct.eavg=0;
          E_struct.e2sum=0; //For calculating heat capacity

          C_struct.conc_avg.assign((num_type+1),0.0);//Used for averaging conc.
          C_struct.M4avg.assign((num_type+1),0.0);//Used for calculating U4 (magnetic)
          C_struct.M2avg.assign((num_type+1),0.0);//Used for calculating U4 (magnetic)
          //cout<<"Initial Energy at T= "<<T<<" is "<<E_struct.Estart<<endl;

          //End of initialisation------------------------------------------------  
          int countpass=0;//Track no. of passes after equil time
          //Loop over num of passes
          for (passes=1;passes<=numpass;passes++)
          {

            if('c'==canonical)
            {
              metro_canon(T, passes);//Metropolis algorithm: canonical (fixed-c) 
            }
            else
            {
              metro_grand(T, passes);//Metropolis algorithm: Grand canonical.
            }

            //if no. of passes >= no. of passes for equilibration	
            if (passes>equil_pass)
            {
              //cout<<"passes= "<<passes<<" equil_pass= "<<equil_pass<<endl;
              countpass++;//No. of passes after equil time.

              //Summing  energy related terms
              E_struct.E=(E_struct.Estart+E_struct.dEpass);//Energy of system at current pass.
              //cout<<"E_struct.E= "<<E_struct.E<<endl;
              E_struct.e=E_struct.E/natoms;//Energy per atom at current pass
              if (outlevel[0]=='h')
              { print_output3(output3, passes);}//Print energy at each pass
              E_struct.dEsumpass+=E_struct.dEpass;//Sum of all dEpass
              
              //Sum e2
              E_struct.e2sum+=E_struct.e*E_struct.e;

              //Sum up concentration
              cal_conc();
              //Loop over all atom species
              for (int i=0; i<num_type+1;i++)
              {
                C_struct.conc_avg[i]+=C_struct.conc[i];
                tempd=(2*C_struct.conc[i]-1);
                C_struct.M4avg[i]+=tempd*tempd*tempd*tempd;
                C_struct.M2avg[i]+=tempd*tempd;   
              }//end for (int i=0; i<numtype+1;i++

            }//end_if (passes>equil_pass)
          }//end_for(passes=1;passes<=numpass;passes++).

          //Calculate averages-----------------------------------------------------
          //Calculate avg energy 
          E_struct.Eavg=E_struct.Estart+E_struct.dEsumpass/(double)countpass;
          E_struct.eavg=(E_struct.Eavg/natoms);//Average energy per atom

          //Calculate E2avg
          //E_struct.E2avg=E_struct.Estart*E_struct.Estart+2*E_struct.Estart*E_struct.dEsumpass/(double)countpass+E_struct.dE2sumpass/(double)countpass;
          //Calculate E2avg per atom = e2avg
          //E_struct.e2avg=E_struct.E2avg/natoms;

          //Calculate e2avg
          E_struct.e2avg=E_struct.e2sum/(double)countpass;


          //Calculate conc_avg
          for (int i=0; i<num_type+1;i++)
          {
            C_struct.conc_avg[i]/=countpass;
            C_struct.M4avg[i]/= countpass;
            C_struct.M2avg[i]/= countpass;
          }

          //Average the correlation terms
          /*if (correlation_option==1)
            {

            }*/

          //End of calculating averages--------------------------------------------
          if (run>0)
          {
            print_output(outputh, T);//Call func to print data to file(heating)
          }
          else
          {
            print_output(output, T);//Call func to print data to file
          }
          print_output2(output2, T);//Prints T, U4 to file   

          //Prints the final configuration for each T to file.
          config<<"Configuration for T= "<<T<<endl;
          config<<"Average energy= "<<E_struct.Eavg<<endl;
          config<<"Energy of config = "<<E_struct.E<<endl;
          print_config(config);
          cout<<"Temp.= "<<T<<endl;
          output3<<endl<<endl;//Facilities plotting with Gnuplot

          //Next temperature step: T=T+Tchange
          //Following line determines new Tchange
          double Tchange_old=Tchange;
          Tchange=Tincrement*Tsign;
          /*Tchange = Tincrement<?(abs(Tchange*Tchange*(E_struct.dCv_old+1e-10)/(E_struct.Cv-E_struct.Cv_old)/SCALE_FACTOR));
          Tchange = (Tchange>?Tincrement/Tsub)*Tsign;*/
          E_struct.dCv_old=(E_struct.Cv-E_struct.Cv_old)/Tchange_old;
          E_struct.Cv_old=E_struct.Cv;
          
          if (run>0)
          {
            T=T-Tchange;
          }
          else
          {
            T=T+Tchange;
          }

        }//end of temperature loop
      }//End of run loop
    }//End of chem. pot. loop

    output.close();
    if (num_runs>1)
    {
      outputh.close();
    }
    output2.close();
    output3.close();
    config.close();

    // Print final configuration to file, which can be renamed (see filenames.h) for use 
    //as starting config. for next run
    fstream confinal;
    confinal.open(outconf0, ios::out);
    if (!confinal)
    {
      cout<<"File "<<outconf0<<" is not opened!"<<endl;
      exit(1);
    }
    print_config(confinal);
    confinal.close();

    //End of monte carlo simulation==============================================================
  }

  else //if correlation is turned on==============================================================
  {
   
    //Opening files for output---------------------------------------------------
    fstream outcor_pair, outcor_LRO, outcor_LROc;   
 
    output.open(outputfile, ios::out);//Main outputfile. Properties at each T and chem pot
    if (!output)
    {
      cout<<"File "<<outputfile<<" is not opened!"<<endl;
      exit(1);
    }
    if (num_runs>1)
    {
      outputh.open(outputfileh, ios::out);//Main outputfile(heating). Properties at each T and chem pot
      if (!outputh)
      {
        cout<<"File "<<outputfileh<<" is not opened!"<<endl;
        exit(1);
      }
    }

    output2.open(outputfile2, ios::out);// U4 using 4th moment of energy
    if (!output2)
    {
      cout<<"File "<<outputfile2<<" is not opened. No results for U4."<<endl;
      //exit(1);
    }
    output3.open(outputfile3, ios::out);//Energy at each pass.
    if (!output3)
    {
      cout<<"File "<<outputfile3<<" is not opened. "<<endl;
      //exit(1);
    }  
    config.open (outconfigT, ios::out);//Configuration at each temperature.
    if (!config)
    {
      cout<<"File config.out is not opened!"<<endl;
      exit(1);
    } 
    //output<<"#T,       eavg,         e_instant,   Cv,          conc,      mu"<<endl;
    output<<"#T,       "<<"eavg,         "<<"e instant,    "<<"Cv,             ";
    output2<<"#T,       "<<"U4,      ";
    output3<<"#Pass,       "<<" e instant,   "<<endl;
    for (int i=1;i<=num_type;i++)
    {
      output<<"conc "<<i<<",    "<<"mu "<<i<<",     ";
      output2<<"mu "<<i<<",     ";

    } 
    output<<endl;
    output2<<endl;
    outcor_pair.open (outcor_pairfile, ios::out);//Open output file for SRO_pair
    if (!outcor_pair)
    {
      cout<<"File "<<outcor_pairfile<<" is not opened!"<<endl;
      exit(1);
    }
     
    outcor_pair<<"#T ijk1 l1 ijk2 l2 Set of{Typei Typej <P(l1,i)> <P(l2,j> <P(site1,i),P(site2,j)>}"<<endl;

    outcor_LRO.open (outcor_LROfile, ios::out); //Open outputfile for LRO (table format)
    if (!outcor_LRO)
    {
      cout<<"File "<<outcor_LROfile<<" is not opened!"<<endl;
      exit(1);
    }
    outcor_LRO<<"# T  Cell  Sublattice  ";
    for (int i=0;i<=num_type;i++)
    {
      outcor_LRO<<"Type "<<i<<"  ";
    }
    outcor_LRO<<endl;

    outcor_LROc.open (outcor_LROcfile, ios::out); //Open outputfile for LRO (config format)
    if (!outcor_LROc)
    {
      cout<<"File "<<outcor_LROcfile<<" is not opened!"<<endl;
      exit(1);
    }
    

    cout<<"end of opening output files"<<endl;
    //End of opening output files------------------------------------------------

    //Determine which atomic type's mu conditions to loop over-----------
    //mu_step is determined by atomic species with least mu_steps 
    int mu_steps=0;
    //Loop over atomic types and compare the num of mu steps
    for(int i=0; i<num_type;i++)
    {
      double tempmud;
      int tempmu;
      tempmud=(mu_final[i]-mu_init[i])/mu_increment[i];
      tempmu=(int)tempmud;
      if (tempmu<0)
      { 
	      tempmu=0;
      }
      else if (abs(tempmud-tempmu)>0.9999)
      {
	      tempmu+=1 ;
      }
      //tempmu=abs((int)((mu_final[i]-mu_init[i])/mu_increment[i]));
      if (tempmu > mu_steps)
      { 
	      //mu_steps is the no. of steps for mu loop 
	      mu_steps=tempmu;
      }
    }
    //-------------------------------------------------------------------

    //Determine the number of temperature steps-------------------------
    double Tstepsd;
    int Tsteps;
    Tstepsd=(Tfinal-Tinit)/Tincrement;
    Tsteps=(int)Tstepsd;
    if (Tsteps<0)
    { 
      Tsteps=0;
    }
    else if (abs(Tstepsd-Tsteps)>0.9999)
    {
      Tsteps+=1 ;
    }

    //------------------------------------------------------------------


    //Monte Carlo  simulation====================================================

    //Calculate energy of initial system---------------------------------
  
    cal_conc();//Calculate the conc. of initial configuration
        
    //The real simulation------------------------------------------------
    /* The simulation is done in the following manner:
       1. Loops over each chemical potential,temperature & passes.
       2. Energy of lattice with new chem. pot. is calculated
       3. Calls functions metro_grand or metro_canon to calculate energy
	        for each pass.Energy changes, concentration changes and correlated
	        terms (SRO, LRO)for each pass are summed up.
	        E.g E_struct.dEsumpass+=E_struct.dEpass
       4. Calculates average terms for energy, energy^2 and concentration
       5. Prints various outputs.
    */

    //Loop over Chem. Potential
    for (int mu=0; mu <=mu_steps;mu++)
    {
      //Update one body potential in Pots.onebody
      //Loop over sublattice
      for (int l=0; l<num_sublat;l++)
      {
	      //Loop over no. of atomic species
	      for (int k=0;k<num_type;k++)
	      {
	        clustree.sublat[l].nbody[1].nclus[0]->Vin[k]=mu_init[k]+mu_increment[k]*mu;
	      }
      }//end for (int l=0; l<num_sublat;l++)

      E_struct.E=eEnergy();//The system is initialised with new chem pot.
      double tempd;//For temporary storage.

      //Loop num_runs. num_runs=2 if both cooling and heating processes
      //if only cooling process, num_runs=1;
      for (int run=0;run<num_runs;run++)
      { 
        //Loop over temperature
        for (int temp=0; temp<=Tsteps ; temp++)
        { //Initilaisation-------------------------------------------------------
          double T;
          if (run>0)
          {
            T=Tfinal-Tincrement*temp;
          }
          else
          {
            T=Tinit+Tincrement*temp;
          }

          E_struct.Estart=E_struct.E;//Starting energy of sys.=sys. energy from previous loop over T
          E_struct.dEpass=0;
          E_struct.dEsumpass=0;
          E_struct.E=0;
          E_struct.Eavg=0;

          E_struct.e=0;
          E_struct.eavg=0;
          E_struct.e2sum=0; //For calculating heat capacity
          //E_struct.e2avg=0;//For calculating heat capacity per atom.

          C_struct.conc_avg.assign((num_type+1),0.0);//Used for averaging conc.
          C_struct.M4avg.assign((num_type+1),0.0);//Used for calculating U4 (magnetic)
          C_struct.M2avg.assign((num_type+1),0.0);//Used for calculating U4 (magnetic)
          //cout<<"Initial Energy at T= "<<T<<" is "<<E_struct.Estart<<endl;

          //Initialise correlation terms

          //Initialise cor_pair
          int len;
          len=noccupancy[0].site[0].cor_pair[0]->num_instances.size();
          //Loop over no. of sublattice
          for (int l=0; l<num_sublat;l++)
          {
            for (int i=0;i<noccupancy[0].site[l].sub_instances.size();i++)
            {  noccupancy[0].site[l].sub_instances[i]=0;}

            //Loop over no. of correlated pairs
            for (int k=0;k<noccupancy[0].site[0].cor_pair.size();k++)
            {
              //Assign 0 to each correation type <xa, yb>
              noccupancy[0].site[l].cor_pair[k]->num_instances.assign(len,0);
            }
          }

          //Initialise user_def correlation clusters
          //Warning the user_def SRO is not tested!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          //Spatial case
          for (int jj=0;jj<user_def_param_spa.size();jj++)
          {
            int templ, len;
            templ=user_def_param_spa[jj]->coord[0].sublat;
            len=noccupancy[0].site[templ].cor_def_spa[jj]->num_instances.size();
            noccupancy[0].site[templ].cor_def_spa[jj]->num_instances.assign(len,0);
          }

          //Fixed case
          for (int jj=0;jj<user_def_param_fix.size();jj++)
          {
            int templ, len, ijk;
            templ=user_def_param_spa[jj]->coord[0].sublat;
            ijk=user_def_param_spa[jj]->first_cell;
            len=noccupancy[0].site[templ].cor_def_fix[jj]->num_instances.size();
            noccupancy[ijk].site[templ].cor_def_fix[jj]->num_instances.assign(len,0);
          }
          //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

          //LRO case
          for (int i=0;i<noccupancy[0].site[0].LRO_instances.size();i++)
          {
            //Loop over cells    
            for (int ijk=0;ijk<nsize;ijk++)
            {
              //Loop over sublattice
              for (int l=0;l<num_sublat;l++)
              {
                noccupancy[ijk].site[l].LRO_instances[i]=0;
              }
            }
          }

          //End of initialisation------------------------------------------------  

          int countpass=0;//Track no. of passes after equil time
          //Loop over num of passes
          for (passes=1;passes<=numpass;passes++)
          {

            if('c'==canonical)
            {
              metro_canon(T, passes);//Metropolis algorithm: canonical (fixed-c) 
            }
            else
            {
              metro_grand(T, passes);//Metropolis algorithm: Grand canonical.
            }

            //if no. of passes >= no. of passes for equilibration	
            if (passes>equil_pass)
            {
              countpass++;//No. of passes after equil time.

              //Summing  energy related terms
              E_struct.E=(E_struct.Estart+E_struct.dEpass);//Energy of system at current pass.
              E_struct.e=E_struct.E/natoms;//Energy per atom at current pass
              print_output3(output3, passes);//Print energy at each pass
              E_struct.dEsumpass+=E_struct.dEpass;//Sum of all dEpass
              E_struct.e2sum+=E_struct.e*E_struct.e;//Sum e-squared

              //Sum up concentration and correlation terms
              cal_conc_cor();

              //Calculate terms related to U4 
              //Loop over all atom species
              for (int i=0; i<num_type+1;i++)
              {
                C_struct.conc_avg[i]+=C_struct.conc[i];
                tempd=(2*C_struct.conc[i]-1);
                C_struct.M4avg[i]+=tempd*tempd*tempd*tempd;
                C_struct.M2avg[i]+=tempd*tempd;   
              }//end for (int i=0; i<numtype+1;i++

            }//end_if (passes>equil_pass)
          }//end_for(passes=1;passes<=numpass;passes++).

          //Calculate averages-----------------------------------------------------
          //Calculate avg energy 
          E_struct.Eavg=E_struct.Estart+E_struct.dEsumpass/(double)countpass;
          E_struct.eavg=E_struct.Eavg/natoms;//Average energy per atom

          //Calculate e2avg
          E_struct.e2avg=E_struct.e2sum/(double)countpass;


          //Calculate conc_avg
          for (int i=0; i<num_type+1;i++)
          {
            C_struct.conc_avg[i]/=countpass;
            C_struct.M4avg[i]/= countpass;
            C_struct.M2avg[i]/= countpass;
          }

          //End of calculating averages--------------------------------------------
  
          //Printing outputs
          if (run>0)
          {
            print_output(outputh, T);//Call func to print data to file(heating)
          }
          else
          {
            print_output(output, T);//Call func to print data to file
          }
          print_output2(output2, T);//Prints T, U4 to file   

          //Prints the final configuration for each T to file.
          config<<"Configuration for T= "<<T<<endl;
          config<<"Average energy= "<<E_struct.Eavg<<endl;
          config<<"Energy of config = "<<E_struct.E<<endl;
          print_config(config);
          //cout<<"Temp.= "<<T<<endl;
          output3<<endl<<endl;//Facilitates plotting with Gnuplot

          //Functions to print correlation terms
          if (pair_option>0)
          {
            print_corr(outcor_pair,countpass, T);//Print SRO_pair
          }

          if (LRO_option==1)
          {
            //Choose one of them, else it's a waste of time !!!!

            print_LRO(outcor_LRO, countpass, T);//Print terms related to LRO in table format

            print_LROc(outcor_LROc,countpass, T);//Print terms related to LRO in config format 
          }

        }//end of temperature loop
      }//end for num_runs
    }//End of chem. pot. loop

    //Closing output files
    output.close();
    if (num_runs>1)
    {
      outputh.close();
    }
    output2.close();
    output3.close();
    config.close();
    outcor_pair.close();
    outcor_LRO.close();
    outcor_LROc.close();
    
    // Print final configuration to file, which can be renamed (see filenames.h) for use 
    //as starting config. for next run
    fstream confinal;
    confinal.open(outconf0, ios::out);
    if (!confinal)
    {
      cout<<"File "<<outconf0<<" is not opened!"<<endl;
      exit(1);
    }
    print_config(confinal);
    confinal.close();

    //End of monte carlo simulation==================================
  }//end else



}

//EOF
