/* This file is print_LRO.cc 
   Prints the LRO terms
   By Teck Leong Tan
*/

#include "lattice.h"

void Lattice::print_LRO(fstream& out, int countpass, double T)
{

  //outc<<"Temperature= "<<T<<endl;
  //Loop over cells    
  for (int ijk=0;ijk<nsize;ijk++)
  {
    //Loop over sublattice
    for (int l=0;l<num_sublat;l++)
    {
      //Print in table format
      out<<setw(8)<<setiosflags(ios::left)<<T;
      out<<" "<<setw(6)<<ijk;
      out<<" "<<setw(3)<<l<<"   ";      
      for (int i=0;i<noccupancy[0].site[0].LRO_instances.size();i++)
      {
        out<<setw(6)<<noccupancy[ijk].site[l].LRO_instances[i]<<" ";
      }
      out<<endl;

    }
  }
  out<<endl;
}

//EOF
