/* This file is print_LROc.cc
   Member function of Lattice class which prints 
   the LRO in configuration format
   By Teck Leong Tan
*/
#include "lattice.h"

void Lattice::print_LROc(fstream& out, int countpass, double T)
{
  double temp;//Temp. storage for LRO related term
  double param;//Deviation parameter
  vector<double>  param_ave;//Average of param

  param_ave.assign(noccupancy[0].site[0].LRO_instances.size(),0);
  //out<<"Temperature= "<<T<<endl;
  
  //Loop over independent types
  for (int i=1;i<noccupancy[0].site[0].LRO_instances.size();i++)
  {
    out<<"Type "<<i<<endl;
    //Loop over cells    
    for (int ijk=0;ijk<nsize;ijk++)
    {
      //Loop over sublattice
      for (int l=0;l<num_sublat;l++)
      {
        temp=(double)noccupancy[ijk].site[l].LRO_instances[i]/(double)countpass;
                
        if (temp>C_struct.conc_avg[i])
        {
          param = (temp-C_struct.conc_avg[i])/(1-C_struct.conc_avg[i]);
        }
        else
        {
            param=(C_struct.conc_avg[i]-temp)/C_struct.conc_avg[i];
        }
        
        out<<" "<<setiosflags(ios::fixed)<<setw(6)<<setprecision(4);
        out<<param;
        param_ave[i]+=param;
      }
      
      for (int i=ndim-1;i>0;i--)
      {
        //If the end of the box's side is reached, create a new line
        if ((ijk+1)%factor[i]==0) { out<<endl; }
      
      }
      
    }//end loop over cell
    out<<"Temperature= "<<T<<" param_ave= "<<param_ave[i]/(double)natoms;
    out<<endl;
  }
  out<<endl;
}
//EOF
